﻿using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SfListViewSample
{
    public class ContactsViewModel : INotifyPropertyChanged
    {
        #region Fields

        private ObservableCollection<Contacts> contactitems;
        private Random r = new Random();
        SfListView ListView;

        #endregion Fields

        #region Properties

        public ObservableCollection<Contacts> ContactItems
        {
            get { return contactitems; }
            set
            {
                contactitems = value;
                RaisedOnPropertyChanged("ContactItems");
            }
        }

        #endregion Properties

        #region Constructor

        public ContactsViewModel (SfListView listview)
        {
            ListView = listview;
            contactitems = new ObservableCollection<Contacts>();
            LoadData(12);
        }

        #endregion Constructor

        #region Methods

        public void LoadData(int count)
        {
            for (int i = 0; i < 10; i++)
            {
                var contact = new Contacts(CustomerNames[i], r.Next(720, 799).ToString() + " - " + r.Next(3010, 3999).ToString());
                contact.ContactColor = Color.FromRgb(r.Next(40, 255), r.Next(40, 255), r.Next(40, 255));
                contact.ContactImage = ImageSource.FromResource("SfListViewSample.Images.Image" + r.Next(0, 28) + ".png");
                ContactItems.Add(contact);
                contact.PropertyChanged += Contact_PropertyChanged;
            }
            ListView.DataSource.DisplayItems.CollectionChanged += DisplayItems_CollectionChanged;
        }

        private void Contact_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            var name = e.PropertyName;
            App.Current.MainPage.DisplayAlert("Message","Modified Property Name :" +name,"Ok");
        }

        private void DisplayItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            App.Current.MainPage.DisplayAlert("Message", "Collected gets changed","Ok");

        }

        #endregion Methods

        #region ItemsSource

        private string[] CustomerNames = new string[] {
            "Alex",
            "Irene",
             "Katie",
            "Michael",
            "Ralph",
            "Torrey",
            "William",
            "Bill",
            "Daniel",
            "Holly",
            "Jennifer",
            "Liz",
            "Pete",
            "Vince",
            "Zeke",

        };

        private Image image;

        #endregion ItemsSource

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion INotifyPropertyChanged Interface
    }
}